package de.V10lator.BukkitHTTPD;

import java.io.File;
import java.nio.CharBuffer;
import java.nio.charset.CharacterCodingException;
import java.nio.charset.Charset;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class BukkitHTTPDCommandParser implements CommandExecutor
{
  private final BukkitHTTPD plugin;
  
  public BukkitHTTPDCommandParser(BukkitHTTPD plugin)
  {
	this.plugin = plugin;
  }
  
  public boolean onCommand(CommandSender sender, Command arg1, String arg2,
			String[] args)
  {
	boolean pw = (args.length > 1 && args[0].equalsIgnoreCase("password"));
	if(!sender.hasPermission("bukkithttpd.admin") || pw)
	{
	  if(!sender.hasPermission("bukkithttpd.user") || !(sender instanceof Player))
	    return true;
	  if(!pw)
	    sendHelp(sender);
	  else
	  {
		String passwd;
		if(args.length > 2)
		{
		  StringBuilder sb = new StringBuilder(args[1]);
		  for(int i = 2; i < args.length; i++)
		  {
			sb.append(args[i]);
			sb.append(" ");
		  }
		  passwd = sb.toString().trim();
		}
		else
		  passwd = args[1].trim();
		try
		{
		  MessageDigest md = MessageDigest.getInstance("SHA");
		  md.update(Charset.forName("UTF-8").newEncoder().encode(CharBuffer.wrap(passwd)));
		  byte[] sha = md.digest();
		  StringBuffer hex = new StringBuffer();
		  for(int i=0; i < sha.length; i++)
		    hex.append(Integer.toHexString(0xFF & sha[i]));
		  
		  while(plugin.ram.lock.compareAndSet(false, true))
			continue;
		  plugin.ram.passwords.put(((Player)sender).getName(), hex.toString());
		  plugin.ram.loggedIn.remove(((Player)sender).getName());
		  plugin.ram.lock.set(false);
		  plugin.saveConfig();
		  sender.sendMessage(ChatColor.GREEN+"Password set.");
		}
		//TODO
		catch(CharacterCodingException e)
		{
		  sender.sendMessage(ChatColor.RED+"Internal error!");
		  e.printStackTrace();
		}
		catch(NoSuchAlgorithmException e)
		{
		  sender.sendMessage(ChatColor.RED+"Internal error!");
		  e.printStackTrace();
		}
	  }
	  return true;
	}
	
	while(plugin.ram.lock.compareAndSet(false, true))
	  continue;
	
	boolean save = false;
	boolean reload = false;
	
	if(args.length < 1 || args[0].equalsIgnoreCase("help"))
	  sendHelp(sender);
	else if(args[0].equalsIgnoreCase("name"))
	{
	  if(args.length < 2)
	  {
		sender.sendMessage(ChatColor.GREEN+"Current server name:");
		sender.sendMessage(ChatColor.YELLOW+plugin.ram.serverName);
	  }
	  else
	  {
		StringBuilder sb = new StringBuilder(args[1]);
		for(int i = 2; i < args.length; i++)
		{
		  sb.append(" ");
		  sb.append(args[i]);
		}
		plugin.ram.serverName = sb.toString();
		save = true;
		sender.sendMessage(ChatColor.YELLOW+"New server name:");
		sender.sendMessage(ChatColor.GREEN+plugin.ram.serverName);
	  }
	}
	else if(args[0].equalsIgnoreCase("port"))
	{
	  if(args.length < 2)
	  {
		sender.sendMessage(ChatColor.GREEN+"Current server port:");
		sender.sendMessage(ChatColor.YELLOW+String.valueOf(plugin.httpdPort)+" ("+ChatColor.GOLD+plugin.ram.hidePort+ChatColor.YELLOW+")");
	  }
	  else
	  {
		try
		{
		  if(args[1].equalsIgnoreCase("hide"))
		  {
			if(plugin.ram.hidePort)
			{
			  plugin.ram.hidePort = false;
			  sender.sendMessage(ChatColor.YELLOW+"Hiding port.");
			}
			else
			{
			  plugin.ram.hidePort = true;
			  sender.sendMessage(ChatColor.GREEN+"Showing port.");
			}
		  }
		  else
		  {
		    plugin.httpdPort = Integer.parseInt(args[1]);
		    sender.sendMessage(ChatColor.YELLOW+"New server port:");
		    sender.sendMessage(ChatColor.GREEN+args[1]);
		  }
		  save = true;
		}
		catch(NumberFormatException e)
		{
		  sender.sendMessage(ChatColor.RED+"Invalid port: \""+ChatColor.GOLD+args[1]+ChatColor.RED+"\"");
		}
	  }
	}
	else if(args[0].equalsIgnoreCase("color"))
	{
	  if(args.length < 2)
	  {
		sender.sendMessage(ChatColor.GREEN+"Current color:");
		sender.sendMessage(ChatColor.YELLOW+plugin.ram.color);
	  }
	  else
	  {
		try
		{
		  Integer.parseInt(args[1]);
		  if(args[1].length() != 6)
			throw new NumberFormatException();
		  plugin.ram.color = args[1];
		  save = true;
		  sender.sendMessage(ChatColor.YELLOW+"New color:");
		  sender.sendMessage(ChatColor.GREEN+plugin.ram.color);
		}
		catch(NumberFormatException e)
		{
		  sender.sendMessage(ChatColor.RED+"Invalid color: \""+ChatColor.GOLD+args[1]+ChatColor.RED+"\"");
		}
	  }
	}
	else if(args[0].equalsIgnoreCase("dir"))
	{
	  if(args.length < 2)
	  {
		sender.sendMessage(ChatColor.GREEN+"Current directory:");
		sender.sendMessage(ChatColor.YELLOW+BukkitHTTPD.wwwDir.toString());
	  }
	  else
	  {
		StringBuilder sb = new StringBuilder(args[1]);
		for(int i = 2; i < args.length; i++)
		{
		  sb.append(" ");
		  sb.append(args[i]);
		}
		BukkitHTTPD.wwwDir = new File(sb.toString());
		save = true;
		sender.sendMessage(ChatColor.YELLOW+"New directory:");
		sender.sendMessage(ChatColor.GREEN+BukkitHTTPD.wwwDir.toString());
	  }
	}
	else if(args[0].equalsIgnoreCase("bans"))
	{
	  if(plugin.ram.minecraftBans)
	  {
		plugin.ram.minecraftBans = false;
		sender.sendMessage(ChatColor.YELLOW+"Ignoring minecraft bans.");
	  }
	  else
	  {
		plugin.ram.minecraftBans = true;
		sender.sendMessage(ChatColor.GREEN+"Using minecraft bans.");
	  }
	}
	else if(args[0].equalsIgnoreCase("reload"))
	  reload = true;
	//TODO: Enable after bugfix.
	/*else if(args[0].equalsIgnoreCase("rmpwd") && args.length > 1)
	{
	  if(plugin.ram.passwords.containsKey(args[1]))
	  {
		plugin.ram.passwords.remove(args[1]);
		plugin.ram.loggedIn.remove(args[1]);
		save = true;
	  }
	  else
		sender.sendMessage(ChatColor.RED+args[1]+" not found!");
	}*/
	else
	  sendHelp(sender);
	
	plugin.ram.lock.set(false);
	if(save)
	{
	  plugin.saveConfig();
	  plugin.reloadConfig();
	  sender.sendMessage(ChatColor.GREEN+"Config saved!");
	}
	else if(reload)
	{
	  plugin.reloadConfig();
	  plugin.reloadConfig();
	  sender.sendMessage(ChatColor.GREEN+"Config reloaded!");
	}
	return true;
  }
  
  private void sendHelp(CommandSender sender)
  {
	if(sender.hasPermission("bukkithttpd.admin"))
	{
	  sender.sendMessage("/httpd name");
	  sender.sendMessage("    Show/set the server name.");
	  sender.sendMessage("/httpd port");
	  sender.sendMessage("    Show/set the server port.");
	  sender.sendMessage("/httpd port hide");
	  sender.sendMessage("    Toggle the port hiding switch.");
	  sender.sendMessage("/httpd color");
	  sender.sendMessage("    Show/set the banner color.");
	  sender.sendMessage("/httpd dir");
	  sender.sendMessage("    Show/set the www folder.");
	  sender.sendMessage("/httpd bans");
	  sender.sendMessage("    Toggle the minecraft bans feature.");
	  sender.sendMessage("/httpd reload");
	  sender.sendMessage("    Reload the configuration from disk.");
	  //TODO: Enable after bugfix.
	  //sender.sendMessage("/httpd rmpwd <User>");
	  //sender.sendMessage("    Delete the BukkitHTTPD password of user <User>.");
	}
	if(sender.hasPermission("bukkithttpd.user") || !(sender instanceof Player))
	{
	  sender.sendMessage("/httpd password <password>");
	  sender.sendMessage("    Set your BukkitHTTPD password.");
	}
	sender.sendMessage("/httpd help");
	sender.sendMessage("    Show this help.");
  }
}
